#++
resol2::anyadir -- adds a vertex between two 'connected' points in a graph

resol2::anyadir(p1,p2,pm,g)
p1,p2 - two vertices which are part of the graph g, joined by an edge
pm    - the new vertex
g     - the graph (which must be a Network::graph)
++#

#++
resol2  - output
                       copia

copia   - a Network::graph which is 'g' with point 'pm' between points 'p1' and 'p2'.
          thus, edge [p1,p2] is deleted and edges [p1,pm] and [p2,pm] are created.
          both edges are in the lexicographic order.
++#
resol2::anyadir:=proc(p1,p2,pm,g)
	   local copia, c, punto,puntomedio,i,k,grafoo;
	 begin
#  c[i] are the resol2::neighbors of p1 and p2, cc[i] are the same but without p1 and p2. #
	   grafoo:=g:punto[1]:=p1:punto[2]:=p2:puntomedio:=pm:
	   copia:=g: # the new graph #
#  copia:=AddVertex(copia,pm): #
	   copia:=DelVertex(copia,[punto[1],punto[2]]):#  eliminate the points (and their edges) #
	   k:=1:
#  convert (....,set) is necessary to deal properly with resol2::neighbors # 
	   c[1]:={seq(resol2::neighbors(punto[1],grafoo)[i],
		      i=[$1..nops(resol2::neighbors(punto[1],grafoo))])}
	   minus {punto[2]}:
	   c[2]:={seq(resol2::neighbors(punto[2],grafoo)[i],
		      i=[$1..nops(resol2::neighbors(punto[2],grafoo))])}
	   minus {punto[1]}:
	   for i from 1 to 2 do
	     copia:=AddVertex(copia,punto[i]): #  put back the points p1, p2 in copia #
	     for k from 1 to nops(c[i]) do
	       if op(c[i],k)<punto[i] then copia:=AddEdge(copia,[op(c[i],k),punto[i]],
							  Eweight=Eweight(grafoo)[[op(c[i],k),(punto[i])]])
	       else copia:=AddEdge(copia,[op(c[i],k),punto[i]],
				   Eweight=Eweight(grafoo)[[punto[i],op(c[i],k)]]):
	       end_if:
	     end_for:
# one can change the last five lines for the next two if names are not important
connect({seq(c[i][k],k=1..nops(c[i]))},punto[i],copia): connect with their neigh-
bors but the other one #
	   end_for:
	   for i from 1 to 2 do
	     if puntomedio<punto[i] then
	       copia:=AddEdge(copia,[puntomedio,punto[i]])
	     else
	       copia:=AddEdge(copia,[puntomedio,punto[i]])
	     end_if:
	   end_for:
# change last for...do by this line up if names not important or not numbers #
	   return(copia):
	 end_proc: