#++
resol2::eigen2: the eigenvalues of 2x2 matrix

resol2::eigen2(a)

a  - the 2x2 matrix
++#

#++
resol2   - output
                   {e1,e2}

{e1,e2}  - the set (domain::set) composed of the *two* eigenvalues of a.
           notice that no parameter test is made, so if a has no [i][j]
           components, for i,j=1,2, then one can get funny results.
++#
resol2::eigen2:=proc(a)
	  local b;
	begin
	  b:=a:
	  return({1/2*b[1][1]+1/2*b[2][2]+1/2*sqrt(b[1][1]^2-2*b[1][1]*b[2][2]+
						   b[2][2]^2+4*b[2][1]*b[1][2]),
		  1/2*b[1][1]+1/2*b[2][2]-1/2*sqrt(b[1][1]^2-2*b[1][1]*b[2][2]+b[2][2]^2+
						   4*b[2][1]*b[1][2])}):
	end_proc:
