#++
resol2::neighbors -- returns the neighbors of a vertex in a graph

resol2::neighbors(vertex,graph)

vertex - the vertex whose neighbors we are computing
graph  - the graph
++#

#++
resol2::neighbors -- output

1)                     vertices

vertices - a 1-parameter list composed of the different vertices of
           'graph' which are connected by an edge to 'vertex'.

2)                     exp(1.0)

exp(1.0) - the floating point number 'e'. This is output when 'vertex'
           is an isolated vertex of 'grafo'.

3)                     error (vertex." is not a vertex of ".graph)

         - whenever 'vertex' is not a vertex of 'graph'.
++#

resol2::neighbors:=proc (vertex,graph)
	     local vertices,i,allvertices,j;
	   begin
	     if (not(IsVertex(graph,vertex))) then error(vertex." is not a vertex of ".graph): end_if:
	     allvertices:=Vertex(graph):
	     j:=1;i:=1;
	     if allvertices=NIL then return: end_if;
	     for i from 1 to nops(allvertices) do
	       if IsEdge(graph,[vertex,allvertices[i]]) or IsEdge(graph,[allvertices[i],vertex])
		 then
		 vertices[j]:=allvertices[i]:
		 j:=j+1:
	       end_if:
	     end_for:
# neighbors returns exp(1.0) if there are no neighbors. This is because nops(NAME)
is one, even if NAME is exactly a name and has no content #
	     if(j=1) then return(exp(1.0)): end_if;
	     return(vertices):
	   end_proc: # End of neighbors #
