#++
resol2::reduccion   -  the initial procedure. checks the values of the input, gives errors if
                       they are not OK and once checked, initializes all the global variables and
                       calls resol2::reduccd

resol2::reduccion(a,x,y,p,texto)

a           -  a list of two polynomials [ax,ay] where the 1-form to be reduced is
               (in standard notation)
                                      ax dx + ay dy
x,y-        - the variables (must be given)
p           - the initial point (in fact, it MUST be [0,0] up to date)
texto       - useles? (sorry, but I do not remember)
++#

#++
PLEASE NOTICE THAT resol2::reduccion USES SEVERAL GLOBAL VARIABLES

resol2::INF        - this variable is initially 0 (false), it is given the value 1 (true) when
                     the procedure has studied the point at infinity in the first blowing-up; that
                     is, the point corresponding to the line xx=0
resol2::GRAFO      - the dual graph of the resolution
resol2::COCIENTES  - the sequence of quotients of eigenvalues at the simple singularities and
                     the kind of singularity (0 means corner, 1 means regular (non-crossing) )
resol2::NUMDIVISOR - the highest value of the divisors we have created
resol2::CONTADOR   - the number of simple singularities found
resol2::SEP        - the number of separatrices
resol2::SEPARATRIX - the 'parametrization' of the separatrices

ALL THIS VARIABLES ARE INITIALIZED AS 'ZERO' (IN THEIR CORRESPONDING DOMAINS) IN resol2::reduccion
AND ALL OF THEM BUT resol::SEPARATRIX are unassigned at the end of resol2::reduccion
++#

resol2::reduccion:=proc(a,x,y,p,texto) 
		     local
		     aa,xx,yy,pp,coci;
		   begin
		     xx:=x:yy:=y:
		     if not(nops(a)=2) then pp:=a," is not a list of length 2":
		       fprint(Unquoted,0,pp): error(""):
		     end_if:
		     aa[1]:=poly(a[1],[xx,yy]):
		     aa[2]:=poly(a[2],[xx,yy]):
		     if aa[1]=FAIL or aa[2]=FAIL then pp:=aa , "is not a list of polynomials\
                        in the variables ", x , " " , y: fprint(Unquoted,0,pp): error ("") end_if:
		     if not (gcd(a[1],a[2])=1) then pp:= a[1] , " and ", a[2] ,
							   " are not relatively prime.":
		       fprint(Unquoted,0,pp):
		       error(""):
		     end_if:
		     aa[1]:=a[1]:
		     aa[2]:=a[2]:
		     if contains({DOM_RAT,DOM_INT,DOM_COMPLEX},domtype(aa[1])) or
		       contains({DOM_RAT,DOM_INT,DOM_COMPLEX},domtype(aa[2]))
		       then error
		       ("the equation is not singular or is trivial.")
		     end_if:
#  next three lines: i do not know how to do it in MuPAD
if not(domtype(aa[1])=DOM_POLY and
domtype(aa[2])=DOM_POLY) 
then error(aa[1],aa[2],` are not polynomials in`,x,y): 
end_if:  #
# initialize global variables #
                     resol2::GRAFO:=Network::new([],[]):
                     resol2::INF:=0:#  I have not looked at "infinity" yet  #
	             resol2::NUMDIVISOR:=0:
	             resol2::SEP:=1:
                     resol2::COCIENTES:=list():# This is an absurd value, but necessary #
                     resol2::SEPARATRIX:=list(): # This is an absurd value, but necessary #
#       _EnvExplicit:=true:  To make MuPAD solve explicity all polyn. up to "any" degree  #
	             pp:=-11:
	             resol2::CONTADOR:=1:
	             coci:=resol2::reduccd(aa[1],aa[2],xx,yy,pp,"0",[0],1):
	             unassign(resol2::CONTADOR,resol2::INF,resol2::NUMDIVISOR,resol2::SEP,
		              resol2::GRAFO,resol2::COCIENTES):
	             return(coci,resol2::SEPARATRIX):
	   end_proc:
